<?php
// $HeadURL: https://joomgallery.org/svn/joomgallery/JG-1.5/JG/trunk/components/com_joomgallery/classes/cooliris.class.php $
// $Id: cooliris.class.php 778 2008-12-13 10:58:58Z aha $
/******************************************************************************\
**   JoomGallery  1.5 Beta 1                                                  **
**   By: JoomGallery::ProjectTeam                                             **
**   Copyright (C) 2008  M. Andreas Boettcher                                 **
**   Based on: PonyGallery ML 2.5.1 by PonyGallery-ML-Team                    **
**   Released under GNU GPL Public License                                    **
**   License: http://www.gnu.org/copyleft/gpl.html or have a look             **
**   at administrator/components/com_joomgallery/LICENSE.TXT                  **
\******************************************************************************/

#### Original Copyright ########################################################
## PonyGallery ML 2.5.1                                                       ##
## By: M. Andreas Boettcher & Benjamin Malte Meier                            ##
## & Andreas Hartmann & The ML-Team                                           ##
## Copyright (C) 2007 M. Andreas Boettcher, All rights reserved.              ##
## Released under GNU GPL Public License                                      ##
################################################################################

// based on code example at http://developer.cooliris.com/rss/php_rss.html

defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );


class Joom_Cooliris{

  var $thumbnailpath;
  var $picturepath;

  var $catid;
  var $catpath;
  var $catallpages;
  var $currentpage;
  var $rows;

  /**
   * Ausgabe eines RSS Feed zur Anzeige in Cooliris
   *
   * @param integer $catid
   * @param integer $catallpages, Anzahl der Seiten, wenn Pagination aktiv
   *                              sonst 1
   * @param integer $currentpage, aktuelle Seite wenn Pagination aktiv, sonst 0
   * @param array $rows, Bilder
   */
  function getxmlfeed($catid,$catallpages,$currentpage,$rows){
    global $thumbnailpath,$picturepath;

    header('Content-type: text/xml');

    $this->thumbnailpath=$thumbnailpath;
    $this->picturepath=$picturepath;

    $this->catid=$catid;
    $this->catpath=Joom_GetCatPath($this->catid);
    $this->catallpages=$catallpages;
    $this->currentpage=$currentpage;
    $this->rows=$rows;

    ob_clean();
    echo $this->getRss();
    exit;
  }

  function getRss(){
    $rss  = $this->getRssHeader();
    $rss .= $this->getRssItems();
    $rss .= $this->getRssFooter();
    return $rss;
  }

  function getRssHeader(){
    global $mosConfig_live_site,$mosConfig_lang,$mosConfig_sitename;

    $rssHeader  = '<?xml version="1.0" encoding="utf-8" standalone="yes"?>
                  <rss version="2.0"
                   xmlns:media="http://search.yahoo.com/mrss/"
                   xmlns:atom="http://www.w3.org/2005/Atom">
                     <channel>
                       <title>'.$mosConfig_sitename.'</title>
                       <link>'.$mosConfig_live_site.'</link>
                       <description>JoomGallery</description>
                       ';

    if ($this->catallpages==1){
      $rssHeader .= '<atom:link rel="self" href="'
                 .urlencode($mosConfig_live_site.'/index.php?option=com_joomgallery&func=viewcategory&catid='
                 .$this->catid.'&cooliris=1').'" />
                 ';
    } else {
      $rssHeader .= '<atom:link rel="self" href="'
                 .urlencode($mosConfig_live_site.'/index.php?option=com_joomgallery&func=viewcategory&catid='
                 .$this->catid.'&startpage='.$this->currentpage.'&cooliris=1').'" />
                 ';
    }

    //nur wenn mehr als eine Seite vorliegt, prev next links untersuchen
    //und ggf. aufbauen
    if ($this->catallpages > 1) {
      //prev Link nur, wenn currentpage > 1
      if ($this->currentpage > 1) {
        $prevpage=$this->currentpage-1;
        $rssHeader .= '<atom:link rel="previous" href="'
                   .urlencode($mosConfig_live_site.'/index.php?option=com_joomgallery&func=viewcategory&catid='
                   .$this->catid.'&startpage='.$prevpage.'&cooliris=1').'" />
                   ';
      }

      //next link nur, wenn noch nicht letzte Seite erreicht
      if ($this->currentpage < $this->catallpages){
        $nextpage = $this->currentpage + 1;
        $rssHeader .= '<atom:link rel="next" href="'
                   .urlencode($mosConfig_live_site.'/index.php?option=com_joomgallery&func=viewcategory&catid='
                   .$this->catid.'&startpage='.$nextpage.'&cooliris=1').'" />
                   ';
      }
    }

    return $rssHeader;
  }

  function getRssFooter(){
    $rssFooter = '  </channel>
</rss>';
    return $rssFooter;
  }

  function getRssItems(){
    global $mosConfig_live_site,$func;
    $rssItems = "";
    $thumbnailpath=$this->thumbnailpath.$this->catpath;
    $picturepath=$this->picturepath.$this->catpath;

    foreach ($this->rows as $picture) {
      $id = $picture->id;

      if (defined('_JEXEC')) {
        $title = $this->getBareText($picture->imgtitle);
        $text = $this->getBareText($picture->imgtext);
      }else{
        $title = utf8_encode($this->getBareText($picture->imgtitle));
        $text = utf8_encode($this->getBareText($picture->imgtext));
      }

      $link = urlencode(JRoute::_('index.php?option=com_joomgallery&func=detail&id='.$picture->id));
      $name = $picture->imgauthor;
      $img_id = $picture->id;

      $link_big = 1;

      $func='detail';//um die Originalbilder anzuzeigen
      $contenturl = Joom_OpenImage($link_big, $picture->id, $this->catpath, $this->catid, $picture->imgfilename, $picture->imgtitle, $picture->imgtext);
      $contenturl = str_replace('" target="_blank','',$contenturl);
            
      $rssItems .= "<item>
      <title>".$title."</title>
      <link>".$link."</link>
      <media:thumbnail url=\"".$thumbnailpath.$picture->imgthumbname ."\" />
      <media:content url=\"". $contenturl ."\" />
      <media:description>".$text."</media:description>
      <guid isPermaLink=\"false\">".$mosConfig_live_site.'/joomgallery-'.$picture->id."</guid>
    </item>\n";

    }
    return $rssItems;
  }

  function getBareText($text){
    $text = htmlspecialchars($text, ENT_QUOTES, 'UTF-8');
    $text = trim($text);
    return $text;
  }
}
?>
