<?php
// $HeadURL: https://joomgallery.org/svn/joomgallery/JG-1.5/JG/trunk/administrator/components/com_joomgallery/includes/admin.comments.php $
// $Id: admin.comments.php 778 2008-12-13 10:58:58Z aha $
/******************************************************************************\
**   JoomGallery  1.5 Beta 1                                                  **
**   By: JoomGallery::ProjectTeam                                             **
**   Copyright (C) 2008  M. Andreas Boettcher                                 **
**   Based on: PonyGallery ML 2.5.1 by PonyGallery-ML-Team                    **
**   Released under GNU GPL Public License                                    **
**   License: http://www.gnu.org/copyleft/gpl.html or have a look             **
**   at administrator/components/com_joomgallery/LICENSE.TXT                  **
\******************************************************************************/

#### Original Copyright ########################################################
## PonyGallery ML 2.5.1                                                       ##
## By: M. Andreas Boettcher & Benjamin Malte Meier                            ##
## & Andreas Hartmann & The ML-Team                                           ##
## Copyright (C) 2007 M. Andreas Boettcher, All rights reserved.              ##
## Released under GNU GPL Public License                                      ##
################################################################################

defined('_JEXEC') or die('Direct Access to this location is not allowed.');

include_once dirname(__FILE__) . '/html/admin.comments.html.php';

class Joom_AdminComments {


  function Joom_AdminComments($task) {
    global $option, $id;

    switch($task) {
      case 'comments':
        $this->Joom_ShowComments($option);
        break;

      case 'publishcmt':
        $this->Joom_PublishComments($id, 1, $option);
        break;

      case 'unpublishcmt':
        $this->Joom_PublishComments($id, 0, $option);
        break;

      case 'approvecmt':
        $this->Joom_ApproveComments($id, 1, $option);
        break;

      case 'rejectcmt':
        $this->Joom_ApproveComments($id, 0, $option);
        break;

      case 'removecmt':
        $this->Joom_RemoveComments($id, $option);
        break;
    }
  }


/******************************************************************************\
*                            Functions / Comments                              *
\******************************************************************************/


function Joom_ShowComments($option) {
  /** portierung **/
  $database = & JFactory::getDBO(); // anstatt global $database;
  /* */

  # Prepare pagelimit choices
  $limit = intval(Joom_mosGetParam('post', 'limit', 10));
  $limitstart = intval( Joom_mosGetParam('post', 'limitstart', 0));

  # Prepare search choices
  $search = trim(strtolower(Joom_mosGetParam('post', 'search', '')));
  $where = array();
  if ($search) {
    $where[] = "LOWER(cmttext) LIKE '%$search%' OR LOWER(u.username) LIKE '%$search%' OR LOWER(cmtname) LIKE '%$search%' ";
  }

  # Get total number of records
  $database->setQuery("SELECT count(*) 
      FROM #__joomgallery_comments AS a "
      ."LEFT JOIN #__users AS u ON userid = u.id " 
      .(count( $where ) ? 'WHERE ' . implode( ' AND ', $where ) : '') );
  $total = $database->loadResult();
  echo $database->getErrorMsg();
  if ($limit > $total) {
    $limitstart = 0;
  }

  /** portierung **/
  # neue PageNavigation
  jimport('joomla.html.pagination');
  $pageNav = new JPagination( $total, $limitstart, $limit );
  /* */

  # Do the main database query
  $database->setQuery("SELECT * 
      FROM #__joomgallery_comments "
      ."LEFT JOIN #__users AS u ON userid = u.id " 
      . (count( $where ) ? 'WHERE ' . implode( ' AND ', $where ) : '')
      . " ORDER BY cmtdate DESC",$pageNav->limitstart, $pageNav->limit);  // portierung: ',$pageNav->limitstart, $pageNav->limit' hinzugefuegt (siehe unten)
      #LIMIT $limitstart, $limit  // portierung: ist jetzt in setQuery (siehe oben) LIMIT $limitstart,$limit" );
  $rows = $database->loadObjectList();
  if ($database->getErrorNum()) {
    echo $database->stderr();
    return false;
  }

  /** portierung **/
  # Folgendes muss jetzt vor Datenbankabfrage stehen
  # Set up page navigation
  #include_once("includes/pageNavigation.php");
  #$pageNav = new mosPageNav($total, $limitstart, $limit);
  /* */

  # Bring it all to the screen
  HTML_Joom_AdminComments::Joom_ShowComments_HTML($option, $rows, $search, 
                                                  $pageNav);
}


function Joom_PublishComments($cid=null, $publish=1, $option) {
  /** portierung **/
  $mainframe = & JFactory::getApplication('administrator');  // anstatt global $mainframe;
  $database = & JFactory::getDBO(); // anstatt global $database;
  /* */

  if (!is_array($cid) || count($cid) < 1) {
    $action = $publish ? 'publish' : 'unpublish';
    echo "<script> alert('"._JGA_ALERT_SELECT_AN_ITEM." $action'); 
          window.history.go(-1);</script>\n";
    exit;
  }

  $cids = implode(',', $cid);

  $database->setQuery( "UPDATE #__joomgallery_comments
      SET published='$publish'
      WHERE cmtid IN ($cids)" );
  if (!$database->query()) {
    echo "<script> alert('".$database->getErrorMsg()."'); 
          window.history.go(-1); </script>\n";
    exit();
  }
  $mainframe->redirect('index.php?option='. $option .'&act=comments');
}


function Joom_ApproveComments($cid=null, $approve=1, $option) {
  /** portierung **/
  $mainframe = & JFactory::getApplication('administrator');  // anstatt global $mainframe;
  $database = & JFactory::getDBO(); // anstatt global $database;
  /* */

  if (!is_array($cid) || count($cid) < 1) {
    $action = $approve ? 'approvecmt' : 'rejectcmt';
    echo "<script> alert('" . _JGA_ALERT_SELECT_AN_ITEM . " $action');
          window.history.go(-1);</script>\n";
    exit;
  }

  $cids = implode(',', $cid);

  $database->setQuery( "UPDATE #__joomgallery_comments
      SET approved='$approve'
      WHERE cmtid IN ($cids)" );
  if (!$database->query()) {
    echo "<script> alert('".$database->getErrorMsg()."'); 
          window.history.go(-1); </script>\n";
    exit();
  }
  $mainframe->redirect('index.php?option='. $option .'&act=comments');
}


function Joom_RemoveComments($cid, $option) {
  /** portierung **/
  $mainframe = & JFactory::getApplication('administrator');  // anstatt global $mainframe;
  $database = & JFactory::getDBO(); // anstatt global $database;
  /* */
  if (!is_array( $cid ) || count( $cid ) < 1) {
    echo "<script> alert('"._JGA_ALERT_SELECT_AN_ITEM_TO_DELETE."'); 
          window.history.go(-1);</script>\n";
    exit;
  }
  if (count($cid)) {
    $cids = implode(',', $cid);
    $database->setQuery( "DELETE 
        FROM #__joomgallery_comments 
        WHERE cmtid IN ($cids)" );
    if (!$database->query()) {
      echo "<script> alert('".$database->getErrorMsg()."'); 
            window.history.go(-1); </script>\n";
    }
  }
  $mainframe->redirect('index.php?option='. $option .'&act=comments');
}

}

?>
