<?php
// $HeadURL: https://joomgallery.org/svn/joomgallery/JG-1.5/JG/trunk/components/com_joomgallery/includes/joom.userpanel.php $
// $Id: joom.userpanel.php 778 2008-12-13 10:58:58Z aha $
/******************************************************************************\
**   JoomGallery  1.5 Beta 1                                                  **
**   By: JoomGallery::ProjectTeam                                             **
**   Copyright (C) 2008  M. Andreas Boettcher                                 **
**   Based on: PonyGallery ML 2.5.1 by PonyGallery-ML-Team                    **
**   Released under GNU GPL Public License                                    **
**   License: http://www.gnu.org/copyleft/gpl.html or have a look             **
**   at administrator/components/com_joomgallery/LICENSE.TXT                  **
\******************************************************************************/

#### Original Copyright ########################################################
## PonyGallery ML 2.5.1                                                       ##
## By: M. Andreas Boettcher & Benjamin Malte Meier                            ##
## & Andreas Hartmann & The ML-Team                                           ##
## Copyright (C) 2007 M. Andreas Boettcher, All rights reserved.              ##
## Released under GNU GPL Public License                                      ##
################################################################################


# Don't allow direct linking
defined ('_JEXEC') or die( 'Direct Access to this location is not allowed.' );

class Joom_UserPanel {

  var $userid;
  var $picid;
  var $adminlogged;
    
  function Joom_UserPanel (&$option,&$func,&$cid) {
    /** portierung **/
    $user = & JFactory::getUser(); // anstatt global $my;
    /* */
    include_once dirname(__FILE__) . '/html/joom.userpanel.html.php';
    $this->userid = intval( Joom_mosGetParam( '', 'uid', 0 ) );
    $this->picid = intval( Joom_mosGetParam( '', 'id', 0 ) );

    if ($user->get('usertype') == 'Administrator' || $user->get('usertype') == 'Super Administrator') {
      $this->adminlogged = true;
    } else {
      $this->adminlogged = false;
    }

    switch ($func) {
      //Overview Pictures and Buttons New Picture and categories
      case 'userpanel':
        $this->Joom_User_PanelShow($option);
        break;
      case 'showusercats':
        $this->Joom_User_CatsShow($option);
        break;
      case 'newusercat':
      case 'editusercat':
        $this->Joom_User_EditUserCat($option,$cid);
        break;
      case 'saveusercat':
        $this->Joom_User_SaveUserCat($option,$cid);
        break;        
      case 'deleteusercat':
        $this->Joom_User_DeleteUserCat($option,$cid);
        break;  
      case 'editpic':
        $this->Joom_User_EditPic($option);
        break;
      case 'savepic':
        $this->Joom_User_SavePic($option);
        break;
      case 'deletepic':
        $this->Joom_User_DeletePic($option);
        break;
      case 'showupload':
        $this->Joom_User_ShowUpload($option);
        break;
      default:
        die();
        break;
    }
  }

  /**
   * Uebersicht aller Bilder
   *
   * @param string $option
   */
  function Joom_User_PanelShow (&$option) {
    $config = new Joom_Config();
    /** portierung **/
    $mainframe = & JFactory::getApplication('site'); // anstatt global $mainframe;
    $database = & JFactory::getDBO(); // anstatt global $database;
    $user = & JFactory::getUser();  // anstatt global $my;
    /* */

    //Button 'Kategorien' wird nur angezeigt, wenn vom User angelegte Kategorien
    //vorhanden sind, die auch im Acces Level gueltig sind oder Backendkategorie
    //mit zutreffendem Acces Level zur Verfuegung steht
    //fuer Admin/SuperAdmin werden alle Backendkategorien angezeigt, Button
    //wird dort immer angezeigt
    if ($this->adminlogged) {
      $showcats=true;
      $showpicupload=true;
    } else {
      //Userkategorien lesen, die bereits angelegt sind und dem Acces Level 
      //des User entsprechen und zusaetzlich dem Acces Level entsprechende
      //Backendkategorien, wenn globale Freigabe im Backend eingestellt

      $query="SELECT cid FROM #__joomgallery_catg";

      if (!$config->jg_userowncatsupload){
        $query .= " WHERE owner IS NOT NULL";    
      }else{
        $query .= " WHERE owner=".$user->get('id');    
      }

      if (!empty($config->jg_category)){
        $query .= " OR cid in ($config->jg_category)";         
      }

      if ($config->jg_usercat && !empty($config->jg_usercategory)) {
        $query .= " OR (cid in ($config->jg_usercategory) AND access <= ".$user->get('aid').")"; 
      }
      $database->setQuery($query);
      $result = $database->loadResultArray();
      
      if (!empty($config->jg_category)){
        $jgcats = explode(',',$config->jg_category);      
      } else {
        $jgcats = array();        
      }
      if ($config->jg_usercat && !empty($config->jg_usercategory)){
        $jgusercats = explode(',',$config->jg_usercategory);        
      } else {
        $jgusercats = array();
      }

      //soll Button fuer Upload angezeigt werden
      //Pruefung, ob im Backend Kategorien fuer den Upload freigegeben sind
      //oder vom User angelegte Kategorien
      //Catids von jg_usercat aus $result entfernen, wenn vorhanden
      //nicht, wenn die Kategorie gleichzeitig fuer den Upload freigegeben ist
      $resultarr = $result;
      if ($config->jg_usercat && !empty($config->jg_usercategory)){        
        $resultarr = array_diff($resultarr,array_diff($jgusercats,$jgcats));       
      }
      if (count($resultarr)==0){
        $showpicupload=false;
      }else{
        $showpicupload=true;
      }
      
      //soll Button Kategorien angezeigt werden
      //Catid von jg_category aus $result entfernen, wenn vorhanden
      //nicht, wenn die Kategorie gleichzeitig fuer Usercats freigegeben ist
      if ($config->jg_usercat && count($jgusercats)){
        $resultarr = $result;
        if (!empty($config->jg_category)){
          $resultarr = array_diff($resultarr, array_diff($jgusercats,$jgcats));
        }
        if (count($resultarr)==0){
          $showcats=false;
        }else{
          $showcats=true;
        }          
      }else{
        $showcats=false;
      }
    }

    //Sortierung
    $sordercat  = intval(Joom_mosGetParam('',"sordercat",0));   
    $sortorder  = '';
    switch($sordercat) {
      case 0:
        $sortorder = 'imgdate ASC';
        break;
      case 1:
        $sortorder = 'imgdate DESC';
        break;
      case 2:
        $sortorder = 'imgtext ASC';
        break;
      case 3:
        $sortorder = 'imgtext DESC';
        break;
      case 4:
        $sortorder = 'imgcounter ASC';
        break;
      case 5:
        $sortorder = 'imgcounter DESC';
        break;      
      case 6:
        $sortorder = 'catid ASC,imgtext ASC';
        break;
      case 7:
        $sortorder = 'catid ASC,imgtext DESC';
        break;
    }
  
    //Filter by Type
    $sortcat = intval(Joom_mosGetParam('',"sortcat",0));    
    $where = '';
    switch($sortcat) {
      case 1: //approved
        $where = 'approved = 1';
        break;
      case 2: //not approved
        $where = 'approved = 0';
        break;
    }

    $query = '';
    //Dem Admin/SuperAdmin werden alle veroeffentlichten Bilder abgezeigt, 
    //wenn die Option im Backend aktiviert ist
    if (($this->adminlogged) && $config->jg_showallpicstoadmin == 1 ) {
      $query= "SELECT *
          FROM #__joomgallery
          WHERE published = '1'";
    } else {
      $query="SELECT *
          FROM #__joomgallery
          WHERE owner=".$user->get('id')."
          AND published = '1'";
    }

    if (!empty($where)) {
      $query .= ' AND '.$where;
    } 
    
    if (!empty($sortorder)) {
      $query .= ' ORDER BY '.$sortorder;
    } 

    $database->setQuery($query);
    $rows = $database->loadObjectList();

    //Sortierung der Bilder
    $o_options[] = JHTML::_('select.option',"0", _JGS_USER_ORDERBY_DATE_ASC);  // portierung: JHTML::_('select.option',... anstatt mosHTML::makeOption(...
    $o_options[] = JHTML::_('select.option',"1", _JGS_USER_ORDERBY_DATE_DESC); // portierung: JHTML::_('select.option',... anstatt mosHTML::makeOption(...
    $o_options[] = JHTML::_('select.option',"2", _JGS_USER_ORDERBY_TITLE_ASC); // portierung: JHTML::_('select.option',... anstatt mosHTML::makeOption(...
    $o_options[] = JHTML::_('select.option',"3", _JGS_USER_ORDERBY_TITLE_DESC);// portierung: JHTML::_('select.option',... anstatt mosHTML::makeOption(...
    $o_options[] = JHTML::_('select.option',"4", _JGS_USER_ORDERBY_HITS_ASC);  // portierung: JHTML::_('select.option',... anstatt mosHTML::makeOption(...
    $o_options[] = JHTML::_('select.option',"5", _JGS_USER_ORDERBY_HITS_DESC); // portierung: JHTML::_('select.option',... anstatt mosHTML::makeOption(...
    $o_options[] = JHTML::_('select.option',"6", _JGS_USER_ORDERBY_CATNAME_ASC .' - '. _JGS_USER_ORDERBY_TITLE_ASC); // portierung: JHTML::_('select.option',... anstatt mosHTML::makeOption(...
    $o_options[] = JHTML::_('select.option',"7", _JGS_USER_ORDERBY_CATNAME_DESC .' - '. _JGS_USER_ORDERBY_TITLE_DESC); // portierung: JHTML::_('select.option',... anstatt mosHTML::makeOption(...

    $olist = JHTML::_('select.genericlist',$o_options, 'sordercat',
            'class="inputbox" size="1" onchange="adminForm.submit();"',
            'value', 'text', $sordercat); // portierung: JHTML::_('select.genericlist',... anstatt mosHTML::selectList(...

    //Filter
    $s_options[] = JHTML::_('select.option',"0",_JGS_ALL); // portierung: JHTML::_('select.option',... anstatt mosHTML::makeOption(...
    $s_options[] = JHTML::_('select.option',"1", _JGS_APPROVED_ONLY);  // portierung: JHTML::_('select.option',... anstatt mosHTML::makeOption(...
    $s_options[] = JHTML::_('select.option',"2", _JGS_NOT_APPROVED_ONLY);  // portierung: JHTML::_('select.option',... anstatt mosHTML::makeOption(...
    
    $slist = JHTML::_('select.genericlist',$s_options, 'sortcat',
            'class="inputbox" size="1" onchange="adminForm.submit();"',
            'value', 'text', $sortcat); // portierung: JHTML::_('select.genericlist',... anstatt mosHTML::selectList(...
    
    
    HTML_Joom_UserPanel::Joom_User_PanelShow_HTML($showcats,$showpicupload,$olist,$slist,$rows);
  }
  
  /**
   * Uebersicht aller Userkategorien
   *
   * @param string $option
   */
  function Joom_User_CatsShow (&$option) {
    $config = new Joom_Config();
    /** portierung **/
    $database = & JFactory::getDBO(); // anstatt global $database;
    $user = & JFactory::getUser();  // anstatt global $my;
    /* */

    //wenn user = admin* und alle cat angezeigt werden sollen
    if ( $this->adminlogged && $config->jg_showallpicstoadmin == 1 ) {
      $database->setQuery("SELECT cid,name,catpath,catimage,parent,published
          FROM #__joomgallery_catg" );
    } else {
      $database->setQuery("SELECT cid,name,catpath,catimage,parent,published
          FROM #__joomgallery_catg
          WHERE owner=".$user->get('id') );                     
    }
    $rows=$database->loadObjectList();
    
    foreach ($rows as $key => $catobj) {
      //zusaetzlich pruefen, ob die Kategorie Parent ist
      $database->setQuery("SELECT count(cid)
          FROM #__joomgallery_catg
          WHERE parent = $catobj->cid" );
      
      $resultparent=$database->loadResult();
      
      //Bilder in Kategorie
      $database->setQuery("SELECT count(id)
          FROM #__joomgallery
          WHERE catid = $catobj->cid" );       

      $resultpics=$database->loadResult();
      $rows[$key]->piccount = $resultpics;
          
      if ($resultparent > 0 || $resultpics > 0) {
        $rows[$key]->allowdel = false;        
      } else {
        $rows[$key]->allowdel = true;
      }
    }
    
    HTML_Joom_UserPanel::Joom_User_CatsShow_HTML($rows);
  }
  
  /**
   * Aendern einer bestehenden Kategorie oder Anlegen einer neuen Kategorie
   *
   * @param string $option
   * @param int $cid category, if null -> new category
   */
  function Joom_User_EditUserCat (&$option,$cid) {
    global $mosConfig_live_site;
    $config = new Joom_Config();
    /** portierung **/
    $database = & JFactory::getDBO(); // anstatt global $database;
    $user = & JFactory::getUser();  // anstatt global $my;
    /* */

    // Erstellung der Auswahlliste fuer die Veroeffentlichung
    $yesno[] = JHTML::_('select.option','1', _JGS_YES); // portierung: JHTML::_('select.option',... anstatt mosHTML::makeOption(...
    $yesno[] = JHTML::_('select.option','0', _JGS_NO);  // portierung: JHTML::_('select.option',... anstatt mosHTML::makeOption(...

    // Erstellung der Liste fuer die Anordnung der Kategorie
    $orders = JHTML::_('list.genericordering',"SELECT ordering AS value, name AS text
        FROM #__joomgallery_catg
        WHERE owner = ".$user->get('id')."
        ORDER BY ordering");  // portierung: JHTML::_('list.genericordering',... anstatt mosGetOrderingList(...

    if ($cid != 0){
      // existierende Kategorie
      $row = new mosCatgs($database);
      $row->load( $cid );

      //dem Admin/SuperAdmin werden alle Kategorien angezeigt
      if ($this->adminlogged) {
        $Lists['catgs'] = Joom_ShowDropDownCategoryList($row->parent,'parent','',$cid); 
      } else {        
        $Lists['catgs'] = $this->Joom_User_ShowDropDownCategoryList($row->parent,$cid,'parent');
      }

      // Auswahlliste fuer die Veroeffentlichung
      $publist = JHTML::_('select.genericlist',$yesno, 'published', 
                                     'class="inputbox" size="1"',
                                     'value', 'text', $row->published); // portierung: JHTML::_('select.genericlist',... anstatt mosHTML::selectList(...

      //Anordnung der Kategorie
      $orderlist = JHTML::_('select.genericlist',$orders, 'ordering', 'class="inputbox" size="1"',
                                       'value', 'text', intval($row->ordering));  // portierung: JHTML::_('select.genericlist',... anstatt mosHTML::selectList(...
      $description = $row->description;
      $name = $row->name;

      //wenn Acces Level im Frontend geaendert werden duerfen ,die Access Level
      //suchen,die zwischen der aid des user und dem im Backend eingestellten
      //Level der parent Kategorie liegen
      $glist = null;            
      if ($config->jg_usercatacc || $this->adminlogged) {
        $query="SELECT id AS value, name AS text FROM #__groups";       
        
        //wenn Admin oder SuperAdmin werden alle Level angezeigt
        if (!$this->adminlogged) {
          //parent Kategorie lesen
          $row2 = new mosCatgs($database);
          $row2->load( $row->parent );        
          $query .= " WHERE id >= ".$row2->access." AND id <= ".$user->get('aid');                              
        }
        $query .= " ORDER BY id";      
        $database->setQuery($query);      
        $groups = $database->loadObjectList();

        //wenn nur ein Eintrag gefunden wurde, wird die Auswahl nicht angezeigt
        if (count($groups) > 1) {
          $glist = JHTML::_('select.genericlist',$groups, 'access', 'class="inputbox" size="1"',
          'value', 'text', intval($row->access));          
        }
      }     
    } else {
      //Neue Kategorie
      //dem Admin/SuperAdmin werden alle Kategorien angezeigt
      if ($this->adminlogged) {
        $Lists['catgs'] = Joom_ShowDropDownCategoryList(0, 'parent', '');
      } else {        
        $Lists['catgs'] = $this->Joom_User_ShowDropDownCategoryList(0,null,'parent');
      }      
      
      //Admin/SuperAdmin werden bei Neuanlage alle Access Level angezeigt
      //sonst keine -> dann wird der Level des Parent uebernommen
      $glist = null;            
      if ($this->adminlogged) {
        $query="SELECT id AS value, name AS text FROM #__groups
                ORDER BY id";

        $database->setQuery($query);      
        $groups = $database->loadObjectList();

        if (count($groups) > 1) {
          $glist = JHTML::_('select.genericlist', $groups, 'access', 'class="inputbox" size="1"',
          'value', 'text', 0);
        }
      } 
                
      // Auswahlliste fuer die Veroeffentlichung
      $publist = JHTML::_('select.genericlist',$yesno, 'published', 
                                     'class="inputbox" size="1"',
                                     'value', 'text',0);  // portierung: JHTML::_('select.genericlist',... anstatt mosHTML::selectList(...
      //Anordnung der Kategorie
      $orderlist = JHTML::_('select.genericlist',$orders, 'ordering', 
                                       'class="inputbox" size="1"',
                                       'value', 'text',1);  // portierung: JHTML::_('select.genericlist',... anstatt mosHTML::selectList(...
      $description = '';
      $name = '';
    }

    // Erstellung der Liste der verfuegbaren und genehmigten
    // Kategorie-Thumbnails, nur bei existierenden Kategorien
    $thumblist = null;
    if ($cid!=0) {
      $database->setQuery("SELECT imgthumbname
          FROM #__joomgallery
          WHERE catid=$cid
          AND approved = 1
          ORDER BY imgthumbname");
      
      $thuFiles2 = $database->loadObjectList();
      $thumbs   = array(JHTML::_('select.option','', _JGS_SELECT_THUMBNAIL));  // portierung: JHTML::_('select.option',... anstatt mosHTML::makeOption(...
      foreach ($thuFiles2 as $tfile2) {
          $thumbs[] = JHTML::_('select.option', $tfile2->imgthumbname);  // portierung: JHTML::_('select.option',... anstatt mosHTML::makeOption(...
      }
      $catpath    = Joom_GetCatPath($cid);
  
      $thumblist = JHTML::_('select.genericlist',$thumbs, 'catimage', 'class=\"inputbox\" size=\"1\"'
      . " onchange=\"javascript:"
      . "if (document.usercatForm.catimage.options[selectedIndex].value!='') {"
      .   "document.imagelib.src='$mosConfig_live_site/".$config->jg_paththumbs."/$catpath' "
      .   "+ document.usercatForm.catimage.options[selectedIndex].value"
      . "} else {"
      .   "document.imagelib.src='$mosConfig_live_site/images/M_images/blank.png'}\"",
        'value', 'text', $row->catimage); // portierung: JHTML::_('select.genericlist',... anstatt mosHTML::selectList(...
    }
    HTML_Joom_UserPanel::Joom_User_EditUserCat_HTML($cid,$option, $publist, $glist,
                                                    $Lists, $orderlist,$thumblist,
                                                    $description,$name);
  } 
  
  /**
   * Speichern einer geaenderten oder einer neuen Kategorie
   *
   * @param string $option
   * @param integer $cid, if null -> new category
   */
  function Joom_User_SaveUserCat (&$option,&$cid){
    global $absolut_originalpath, $absolut_picturepath, $absolut_thumbnailpath;
    $config = new Joom_Config();
    /** portierung **/
    $mainframe = & JFactory::getApplication('site');  // anstatt global $mainframe;
    $database = & JFactory::getDBO(); // anstatt global $database;
    $user = & JFactory::getUser();  // anstatt global $my;
    /* */

    $row = new mosCatgs($database);

    if ($cid == 0) {
      $newcat = true;
    } else {
      $newcat = false;
      //bestehende Kategorie einlesen
      $row->load( $cid );
      //alte Parentzuordnung lesen
      $parentold = $row->parent;
      //alten Namen lesen
      $catnameold = $row->name;
    }

    //neue Werte einlesen
    if (!$row->bind($_POST)) {
      echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
      exit();
    }

    if(get_magic_quotes_gpc()) {
      $row->name = stripslashes($row->name);
      $row->description = stripslashes($row->description);
    }

    if (!$newcat) {
      if ($catnameold != $row->name){
        // Macht den neuen Kategorienamen sicher, wenn geaendert
        JFilterOutput::objectHTMLSafe($row->name);  // portierung: () anstatt mosMakeHtmlSafe()
        // Joom_FixCatname; Umlaute werden umgewandelt und alle Sonderzeichen bis auf
        // den Unterstrich entfernt, gilt nur fuer den catpath
        $catname = Joom_FixCatname($row->name);
        $catnamemodif = true;
      } else {
        $catname = $catnameold;
        $catnamemodif = false;
      }
    
      //Kategorieordner verschieben, wenn die Parentzuordnung oder der Kategoriename
      //geaendert wurde
      if ($parentold != $row->parent || $catnamemodif == true){
        //alten Pfad sichern
        $catpathold = $row->catpath;
        
        //Kategoriepfad der Parent-Kategorie lesen, nur noetig wenn parent != 0
        if ($row->parent != 0) {
          $row_parent = new mosCatgs($database);
          $row_parent->load($row->parent);          
          $catpathnew = $row_parent->catpath . '/' .$catname . '_' . $row->cid;
        } else {
          $catpathnew = $catname . '_' . $row->cid;
        }        
        
        //Kategoriepfad in DB aktualisieren
        $row->catpath=$catpathnew;
        
        $cat_originalpathold  = $absolut_originalpath.$catpathold;
        $cat_picturepathold   = $absolut_picturepath.$catpathold;
        $cat_thumbnailpathold = $absolut_thumbnailpath.$catpathold;
    
        $cat_originalpathnew  = $absolut_originalpath.$catpathnew;
        $cat_picturepathnew   = $absolut_picturepath.$catpathnew;
        $cat_thumbnailpathnew = $absolut_thumbnailpath.$catpathnew;

        
        //Ordner verschieben    
        //TODO Fehlermeldungen
        Joom_MoveDir($cat_originalpathold,$cat_originalpathnew);
        Joom_MoveDir($cat_picturepathold,$cat_picturepathnew);
        Joom_MoveDir($cat_thumbnailpathold,$cat_thumbnailpathnew);
    
        //wenn Parentkategorie geaendert wurde, den Catpath aller Unterkategorien
        //in DB anpassen
        $rowid=$row->cid;
        Joom_UpdateNewCatpath($rowid,$catpathold,$catpathnew);
      }
      if (!$row->store()) {
        echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
        exit();
      }
    } else {
      //Neue Kategorie
      //Kategorienamen absichern
      JFilterOutput::objectHTMLSafe($row->name);  // portierung: () anstatt mosMakeHtmlSafe()
      // Joom_FixCatname; Umlaute werden umgewandelt und alle Sonderzeichen bis auf
      // den Unterstrich entfernt, gilt nur fuer den catpath
      $catname = Joom_FixCatname($row->name);
      $row->img_position = 0;
      $row->catimage = null;

      //access von der Elternkategorie erben, wenn nicht Admin/SuperAdmin
      if (!$this->adminlogged) {
        $row->owner = $user->get('id');
        $rowparent = new mosCatgs($database);
        $rowparent->load( $row->parent );
        $row->access = $rowparent->access;
      } else {
        $row->owner = null;
      }

      //Anlegen des DB Eintrages
      if (!$row->store()) {
        echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
        exit();
      }

      //catpath mit vergebener cid aufbauen
      $parentpathnew = Joom_GetCatPath($row->parent);

      $catpathnew = $parentpathnew . $catname . '_' . $row->cid;
      $row->catpath=$catpathnew;

      $row->store();

      //Kategorieverzeichnisse anlegen
      Joom_MakeDirectory($absolut_originalpath.$catpathnew);
      Joom_MakeDirectory($absolut_picturepath.$catpathnew);
      Joom_MakeDirectory($absolut_thumbnailpath.$catpathnew);
    }

    // Redirect zur Kategorieuebersicht
    $mainframe->redirect(JRoute::_('index.php?option='.$option.'&func=showusercats&uid='.$user->get('id')._JOOM_ITEMID,false));
  }
   
/**
* Loeschen einer Kategorie
*
* @param string $option
*/
  function Joom_User_DeleteUserCat(&$option,&$cid) {
    global $absolut_originalpath, $absolut_picturepath,
           $absolut_thumbnailpath;
    /** portierung **/
    $mainframe = & JFactory::getApplication('site');  // anstatt global $mainframe;
    $database = & JFactory::getDBO(); // anstatt global $database;
    $user = & JFactory::getUser();  // anstatt global $my;
    /* */
           
    //ueberpruefen, ob der User Owner der Kategorie ist
    $row = new moscatgs( $database );
    $row->load($cid);

    if(!$this->adminlogged) {
      if ($row->owner != $user->get('id') ) {
        //sie sind nicht berechtigt...
        echo JText::_('ALERTNOTAUTH');
	      if ($user->get('id') < 1) {
		      echo "<br />" . JText::_( 'You need to login.' );
        }
        #mosNotAuth();
        exit;
      }
    }

    //direkte URL-Aufrufe verhindern
    //zusaetzlich pruefen, ob die Kategorie Parent ist oder Bilder enthaelt
    $database->setQuery("SELECT count(cid)
        FROM #__joomgallery_catg
        WHERE parent = $cid" );

    $resultparent=$database->loadResult();
     if ($resultparent > 0) {
      //sie sind nicht berechtigt...
      echo JText::_('ALERTNOTAUTH');
	    if ($user->get('id') < 1) {
		  echo "<br />" . JText::_( 'You need to login.' );
      }
      #mosNotAuth();
      exit;
    }
    //Bilder in Kategorie
    $database->setQuery("SELECT count(id)
        FROM #__joomgallery
        WHERE catid = $cid" );       

    $resultpics=$database->loadResult();

    if ($resultpics > 0) {
      //sie sind nicht berechtigt...
      echo JText::_('ALERTNOTAUTH');
	    if ($user->get('id') < 1) {
		    echo "<br />" . JText::_( 'You need to login.' );
      }
      #mosNotAuth();
      exit;
    }

    $returnval = array();
    $returnval[] = Joom_DeleteDirectory($absolut_originalpath . $row->catpath.'/');
    $returnval[] = Joom_DeleteDirectory($absolut_picturepath . $row->catpath.'/');
    $returnval[] = Joom_DeleteDirectory($absolut_thumbnailpath . $row->catpath.'/');

    if (in_array(false,$returnval)) {
      $mainframe->redirect(JRoute::_('index.php?option=com_joomgallery&func=showusercats&uid='.$user->get('id')._JOOM_ITEMID,false), _JGS_ERROR_DELETING_CATEGORY_DIRECTORY);
      return;
    }

    //DB-Eintrag loeschen
    if ($row->delete() != true) {
      $mainframe->redirect(JRoute::_('index.php?option=com_joomgallery&func=showusercats&uid='.$user->get('id')._JOOM_ITEMID,false), _JGS_ERROR_DELETING_CATEGORY_DATABASE_ENTRY);
      return;
    }

    $mainframe->redirect(JRoute::_('index.php?option=com_joomgallery&func=showusercats&uid='.$user->get('id')._JOOM_ITEMID,false),_JGS_SUCCESS_DELETING_CATEGORY);
  }

/**
* Aendern einer bestehenden Kategorie
*
* @param string $option
*/
  function Joom_User_EditPic (&$option) {
    $config = new Joom_Config();
    /** portierung **/
    $mainframe = & JFactory::getApplication('site');  // anstatt global $mainframe;
    $database = & JFactory::getDBO(); // anstatt global $database;
    $user = & JFactory::getUser();  // anstatt global $my;
    /* */

    $row = new mosjoomgallery( $database );
    $row->load( $this->picid );

    if ($row->owner != $user->get('id') && !$this->adminlogged) {
      $mainframe->redirect(JRoute::_('index.php?option=com_joomgallery'._JOOM_ITEMID,false),_JGS_ALERT_NOT_ALLOWED_TO_EDIT_PICTURE);
    }
    if ($this->adminlogged){
      $clist = Joom_ShowDropDownCategoryList($row->catid, 'catid');          
    } else {
      $clist = $this->Joom_User_ShowDropDownCategoryList($row->catid);      
    }
    
    //wenn $clist = null, wurde das Bild in eine Backend-Kategorie geladen, 
    //die nicht mehr freigeschaltet ist. Oder es handelt sich um die einzige 
    //Kategorie. In diesem Fall nur den Text der Kategorie ausgeben
    if ($clist==null){
      $rowcat = new mosCatgs($database);
      $rowcat->load( $row->catid );
      $clist=$rowcat->name;
    }
    HTML_Joom_UserPanel::Joom_User_EditPic_HTML($option,$row,$clist);
  }

/**
* Sicherung der Aenderungen an dem Bild
*
* @param string $option
*/
  function Joom_User_SavePic (&$option) {
    global $absolut_originalpath,
           $absolut_picturepath,$absolut_thumbnailpath;
    $config = new Joom_Config();
    /** portierung **/
    $mainframe = & JFactory::getApplication('site');  // anstatt global $mainframe;
    $database = & JFactory::getDBO(); // anstatt global $database;
    $user = & JFactory::getUser();  // anstatt global $my;
    /* */

    $row = new mosjoomgallery($database);

    //bestehenden DB Eintrag einlesen
    $row->load($this->picid);

    //alte Angaben sichern
    $catid_old=$row->catid;
    $catpath_old=Joom_GetCatPath($row->catid);

    if (!$row->bind($_POST)) {
      echo "<script> alert('" . $row->getError() . "'); window.history.go(-1); </script>\n";
      exit();
    }

    if(get_magic_quotes_gpc()) {
      $row->imgtitle = stripslashes($row->imgtitle);
      $row->imgtext = stripslashes($row->imgtext);
    }

    //wenn sich die Kategorie geaendert hat, die Bilddateien verschieben
    if ($catid_old != $row->catid){
        $catpathold = $catpath_old;
        $catpathnew = Joom_GetCatPath($row->catid);

        $cat_originalpathold  = $absolut_originalpath.$catpath_old;
        $cat_picturepathold   = $absolut_picturepath.$catpath_old;
        $cat_thumbnailpathold = $absolut_thumbnailpath.$catpath_old;

        $cat_originalpathnew  = $absolut_originalpath.$catpathnew;
        $cat_picturepathnew   = $absolut_picturepath.$catpathnew;
        $cat_thumbnailpathnew = $absolut_thumbnailpath.$catpathnew;

        Joom_MoveFile($cat_originalpathold.$row->imgfilename,$cat_originalpathnew,$row->imgfilename);
        Joom_MoveFile($cat_picturepathold.$row->imgfilename,$cat_picturepathnew,$row->imgfilename);
        Joom_MoveFile($cat_thumbnailpathold.$row->imgfilename,$cat_thumbnailpathnew,$row->imgfilename);
    }

    if ( !$row->store() ) {
      echo "<script> alert('" . $row->getError() . "'); window.history.go(-1); </script>\n";
      exit();
    }
    $mainframe->redirect(JRoute::_('index.php?option=com_joomgallery&func=userpanel'._JOOM_ITEMID,false),_JGS_ALERT_PICTURE_SUCCESSFULLY_UPDATED);
  }

/**
* Loeschen eines Bildes
*
* @param string $option
*/
  function Joom_User_DeletePic (&$option) {
    $config = new Joom_Config();
    /** portierung **/
    $mainframe = & JFactory::getApplication('site');  // anstatt global $mainframe;
    $database = & JFactory::getDBO(); // anstatt global $database;
    $user = & JFactory::getUser();  // anstatt global $my;
    /* */

    if ($this->userid != $user->get('id') && !$this->adminlogged) {
      $mainframe->redirect(JRoute::_('index.php?option=com_joomgallery&func=userpanel'._JOOM_ITEMID,false), _JGS_ALERT_NOT_ALLOWED_DELETE_PICTURE);
    }
    if ($this->picid) {
      $row = new mosjoomgallery($database);
      $row->load($this->picid);
      $catpath=Joom_GetCatPath($row->catid);
      //Detailbild loeschen
      if (unlink( _JOOM_ABSOLUTE_PATH . $config->jg_pathimages . "/" . $catpath . $row->imgfilename)) {
        //Thumb loeschen
        if ( unlink( _JOOM_ABSOLUTE_PATH . $config->jg_paththumbs . "/" . $catpath . $row->imgthumbname )) {
          // ggf. Originalbild loeschen
          if (file_exists(_JOOM_ABSOLUTE_PATH . $config->jg_pathoriginalimages . "/" . $catpath . $row->imgfilename)) {
            unlink( _JOOM_ABSOLUTE_PATH . $config->jg_pathoriginalimages . "/" . $catpath . $row->imgfilename);
          }
          //Kommentare loeschen
          $database->setQuery("DELETE FROM #__joomgallery_comments
            WHERE cmtpic=$this->picid");
          if (!$database->query()) {
            echo "<script> alert('" . $database->getErrorMsg() . "'); window.history.go(-1); </script>\n";
          }

          //Namensschilder loeschen
          $database->setQuery("DELETE FROM #__joomgallery_nameshields
            WHERE nid=$this->picid");
          if (!$database->query()) {
            echo "<script> alert('" . $database->getErrorMsg() . "'); window.history.go(-1); </script>\n";
          }

          //Bild loeschen
          $database->setQuery("DELETE FROM #__joomgallery
            WHERE id=$this->picid");
          if (!$database->query()) {
            echo "<script> alert('" . $database->getErrorMsg() . "'); window.history.go(-1); </script>\n";
          }
        } else {
          die(_JGS_COULD_NOT_DELETE_THUMBNAIL_FILE);
        }
      } else {
        die(_JGS_COULD_NOT_DELETE_PICTURE_FILE);
      }
      $mainframe->redirect(JRoute::_('index.php?option=com_joomgallery&func=userpanel'._JOOM_ITEMID,false),_JGS_ALERT_PICTURE_AND_COMMENTS_DELETED);
    }
  }

/**
* Upload eines oder mehrerer Bilder
*
* @param string $option
*/
  function Joom_User_ShowUpload (&$option) {

    //fuer Admin/SuperAdmin werden alle Kategorien angezeigt
    if ($this->adminlogged) {
      $clist = Joom_ShowDropDownCategoryList(0,'catid',' class="inputbox"');
    } else {
      //wenn $config->jg_userowncatsupload=true, duerfen user nur in eigens erstellte
      //User-Kategorien hochladen
      $clist = $this->Joom_User_ShowDropDownCategoryList(0,null,'catid',true);
    }
    HTML_Joom_UserPanel::Joom_User_ShowUpload_HTML($option,$clist);
  }

/**
 * Aufbau HTML Auswahlliste der vom User angelegten Kategorien
 * und der fuer den Upload freigegebenen Katgeorien
 * @param int catid akt cat oder parent
 * @param int $ignoreme cid, ignoriere die Untercats dieser cat
 * @param string Name fuer das HTML Element, catid oder parent
 * @param bool wenn true, 
 * @return string HTML
 */
  function Joom_User_ShowDropDownCategoryList($cid,$ignoreme=null,$cname="catid",$upload=false) {
    $config = new Joom_Config();
    /** portierung **/
    $database = & JFactory::getDBO(); // anstatt global $database;
    $user = & JFactory::getUser();  // anstatt global $my;
    /* */

    //im Backend fuer den Userupload freigegebene Kategorien
    if ($upload){
      if (!empty($config->jg_category)) {
        $allowedcats = $config->jg_category;
      } 
    }else{
      //im Backend fuer die Anlage von Userkategorien freigegebene Kategorien    
      if (!empty($config->jg_usercategory)) {
        $allowedcats = $config->jg_usercategory;
      } else {
        $allowedcats = "";    
      }      
    }

    $query = "SELECT cid, parent, name ,'0' as ready
        FROM #__joomgallery_catg";

    if ($upload && !$config->jg_userowncatsupload){
      $query .= " WHERE owner IS NOT NULL";    
    }else{
      $query .= " WHERE owner=".$user->get('id');    
    }

    if (!empty($allowedcats)) {
      $query .= " OR cid in ($allowedcats)";
    }

    $database->setQuery($query);
    $rows = $database->loadObjectList("cid");

    $countrows=count($rows);

    if ($countrows==0 && $upload) {
      return null;
    }

    $output = "<select name=\"".$cname."\" class=\"inputbox\">\n";

    if ($countrows==0){
      $output .= "</select>\n";
      return $output;    
    }

    //wenn cname = parent und ignoreme != null, dann die Cats loeschen, die direkt
    //oder indirekt child der cat=ignoreme sind, 
    //$cid = Cat des Parent, $ignoreme=akt. Cat
    //nur bei Edit Cat
    if ($cname=="parent" && $ignoreme != null){
      $ignorearr=array();//zu ignorierende cats
      $ignorearr[]=$ignoreme;//akt. Cat aufnehmen
      $backendcats=explode(',',$allowedcats);
      foreach ($rows as $key => $obj){
        //wenn Backendcat -> ueberspringen
        //ebenso die aktuelle Cat
        if (in_array($key,$backendcats) || $key == $ignoreme){
          continue;
        }
        $found=false;
        $parent=$obj->parent;
        while (array_key_exists($parent,$rows) && !in_array($key,$ignorearr) && !$found) {
          $ignore[]=$key;
          if ($parent==$ignoreme){
            $found=true;          
            break;
          }
          $parent=$rows[$parent]->parent;
        }
        if (!$found){
          $ignore=array();
        } else {
          $ignorearr=array_merge($ignorearr,$ignore);
        }
      }

      //aus Array die in $ignore gesammelten nicht auszugebenden cats entfernen
      foreach ($ignorearr as $catignore){
        unset ($rows[$catignore]);  
      }
    }

    //wenn nur eine Kategorie vorhanden, ist es eine im Backend angelegte und fuer
    //User freigegebene
    if (count($rows)>1){
      //Iteration durch das Array und Komplettierung des Pfades
      foreach ($rows as $key => $obj) {
        $parent=$obj->parent;

        //wenn Rootkategorie, naechstes Element
        if ($parent != 0){
          //wenn Pfad des Parent schon aufgebaut, sofort uebernehmen
          if (isset ($rows[$parent])) {
            if ($rows[$parent]->ready){
              $rows[$key]->name = $rows[$parent]->name . ' &raquo; ' . $rows[$key]->name;
              //break;
            } else {
              while ($parent!=0){
                $rows[$key]->name = $rows[$parent]->name . ' &raquo; ' . $rows[$key]->name;       

                //wenn Pfad des aktuellen Parent schon aufgebaut, while abbrechen
                //sonst mit naechstem Parent fortfahren
                if ($rows[$parent]->ready){
                  break;
                }else{
                  $parent=$rows[$parent]->parent;
                }
              }
            }
          }
        }
        $rows[$key]->ready="1"; //Pfad vollstaendig aufgebaut, -> ready
      }    
      //sortieren des Array nach aufgebautem Pfadnamen
      usort( $rows , "Joom_SortCatArray" );
    }

    foreach ($rows as $key => $obj) {
      //Kategorie darf nicht Parent von sich selbst sein
      //if (!$ignoreme || ($ignoreme && $cid != $obj->cid)) {
        $output .="<option value=\"".$obj->cid."\"";
        if($cid==$obj->cid) {
          $output .= " selected=\"selected\"";
        }
        $output .=">".$obj->name."</option>\n";            
      //}
    }
    $output .= "</select>\n";

    return $output; 
  }
}
?>